.nolist
.486		; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none	; case sensitive 

;     include files
      include \masm32\include\windows.inc       ; main windows include file
      include \masm32\include\masm32.inc        ; masm32 library include
;     Windows API include files
      include \masm32\include\gdi32.inc
      include \masm32\include\user32.inc
      include \masm32\include\kernel32.inc
      include \masm32\include\Comctl32.inc
      include \masm32\include\comdlg32.inc
      include \masm32\include\shell32.inc
      include \masm32\include\oleaut32.inc
      include \masm32\include\ole32.inc
      include \masm32\include\msvcrt.inc
      include \masm32\include\dialogs.inc	; macro file for dialogs

; ****      include \masm32\macros\macros.asm         ; masm32 macro file

;     libraries
;     ~~~~~~~~~
      includelib \masm32\lib\masm32.lib         ; masm32 static library

    ; ------------------------------------------
    ; import libraries for Windows API functions
    ; ------------------------------------------
      includelib \masm32\lib\gdi32.lib
      includelib \masm32\lib\user32.lib
      includelib \masm32\lib\kernel32.lib
      includelib \masm32\lib\Comctl32.lib
      includelib \masm32\lib\comdlg32.lib
      includelib \masm32\lib\shell32.lib
      includelib \masm32\lib\oleaut32.lib
      includelib \masm32\lib\ole32.lib
      includelib \masm32\lib\msvcrt.lib

.const
Open_for_input	PROTO:DWORD,:DWORD
Open_for_output	PROTO:DWORD,:DWORD,:DWORD
GfaInput$	PROTO:DWORD,:DWORD,:DWORD
GfaPrint$	PROTO:DWORD,:DWORD,:DWORD

exit	EQU invoke ExitProcess, 0
CHR$	EQU chr$
COPY$	EQU invoke lstrcpy, 
CAT$	EQU invoke lstrcat, 
LocalFromMacro	EQU <LOCAL>
LocSat	EQU <LOCAL SAT[<tsize>]:DWORD>
IsNeg	EQU 80000000h	; eax>= means: eax is negative
IsNegW	EQU 8000h	; GetKeystate needs a WORD

; **** start MASM32 macros ****



MulCat MACRO dest:REQ, strings:VARARG
 push edi
 push esi
 xor edi, edi				;; first call: allocate 32k
 FOR macstr, <strings>
	mov ecx, reparg_offset(macstr)			;; load src
	; .if ecx<99						;; a string len instead of an address...
	; 	sns ecx, "ecx in Mulcat:" 	;; sns=show number and string
	; .endif
	xor eax, eax		;; flag "not yet cleanup", if ecx==0 it means a Null$
	call AddString		;; add one string, similar to CSA$
 ENDM
 xor ecx, ecx			;; not a source, cleanup
 lea edx, dest			;; put address of destination$ in edx
 lea eax, SAT			;; allows automatic cleaning with FreeStrings
 call AddString		;; copy to dest and free the tmp string
 pop esi
 pop edi
ENDM

STR$ MACRO DDvalue
	mov eax, DDvalue
	xor ecx, ecx
	call GfaSTR$
	if workaround
		EXITM <Gfa0Str$>
	else
		EXITM <eax>
	endif
ENDM

STR1$ MACRO DDvalue
	mov eax, DDvalue
	xor ecx, ecx
	inc ecx			;; mov ecx, 1
	call GfaSTR$
	if workaround
		EXITM <Gfa1Str$>
	else
		EXITM <eax>
	endif
ENDM

STR2$ MACRO DDvalue
	mov eax, DDvalue
	mov ecx, 2
	call GfaSTR$
	EXITM <Gfa2Str$>
ENDM

STR3$ MACRO DDvalue
	mov eax, DDvalue
	mov ecx, 3
	call GfaSTR$
	EXITM <Gfa3Str$>
ENDM

reparg MACRO arg
LOCAL nustr
	quot SUBSTR <arg>, 1, 1
	IFIDN quot,<">				;; if 1st char = "
		.data
		nustr db arg, 0			;; write arg to .DATA section
		.code
		EXITM <Addr nustr>	;; append name to ADDR operator
	ELSE
		EXITM <arg>			;; else return arg
	ENDIF
ENDM

reparg_offset MACRO arg
LOCAL nustr
	quot SUBSTR <arg>, 1, 1
	IFIDN quot,<">				;; if 1st char = "
		.data
		nustr db arg, 0			;; write arg to .DATA section
		.code
		EXITM <offset nustr>	;; append name to ADDR operator
	ELSE
		EXITM <arg>			;; else return arg
	ENDIF
ENDM

len MACRO lpString
	invoke szLen,reparg(lpString)
	EXITM <eax>
ENDM

hex$ MACRO DDvalue
LOCAL rvstring
	.data
		rvstring db 12 dup (0)
		align 4
	.code
	invoke dw2hex,DDvalue,ADDR rvstring
	EXITM <ADDR rvstring>
ENDM

chr$ MACRO any_text:VARARG
LOCAL txtname
	.data
        	txtname db any_text, 0
	.code
	EXITM <OFFSET txtname>
ENDM

; **** end MASM32 macros, start GFA macros ****

ClearLocals MACRO tsize:=<20>
    LocalFromMacro SAT[tsize+1]:DWORD
    call ClrLoc
ENDM

CREATE_txt$ MACRO strName:REQ
LOCAL s1, src, macstr
 s1 SUBSTR <strName>,1,@SizeStr(strName)-1
 src CATSTR s1, <_txt>
 macstr CATSTR s1, <$>
 lea edx, SAT
 xor eax, eax			;; len=0, use len(src)
 mov ecx, offset src	;; srcptr for CSA$
 call CSA$
 mov macstr, eax		;; assign (A$=eax)
ENDM

CREATE$ MACRO macstr:REQ, len:REQ, ptr:=<0>	;; len=0 && ptr<>0: use len(ptr)
 lea edx, SAT
 mov eax, len			;; use this macro only once per procedure and string
 mov ecx, ptr
 call CSA$
 mov macstr, eax		;; assign $ created with SysAlloc
ENDM

FreeLocalStrings MACRO
  lea edx, SAT
  call FreeCSA$
ENDM

sns MACRO macnum:REQ, macstr:=<Debug>
	.if snsFlag!=IDCANCEL
		pushad
		invoke dwtoa, macnum, addr snsBuf
		invoke MessageBox, 0, addr snsBuf, reparg(macstr), MB_OKCANCEL
		mov snsFlag, eax
		popad
	.endif
ENDM

LEN MACRO macstr:REQ
 invoke SysStringByteLen, macstr
 EXITM <eax>
ENDM

PRINT MACRO fnu:REQ, pstr:REQ, slen:=<0>
 fnu2 SUBSTR <fnu>,2,1
 invoke GfaPrint$, fnu2, reparg(pstr), slen
ENDM

INPUT MACRO fnu:REQ, tostr:REQ, nBytes:REQ
 fnu2 SUBSTR <fnu>,2,1
 invoke GfaInput$, fnu2, tostr, nBytes
ENDM

OPEN MACRO mc:REQ, fnu:REQ, fname:REQ
 fnu2 SUBSTR <fnu>,2,1
 IFIDN <mc>,<"I">
	invoke Open_for_input, fnu2, reparg(fname)
 ELSE
	invoke Open_for_output, fnu2, reparg(fname), mc
 ENDIF
ENDM

File EQU GfaHash 
GfaHash MACRO fnu:REQ
  EXITM <GfaFH[4*fnu]>
ENDM

CLOSE MACRO fnu:=<10>	;; 0-9 allowed, 10 means close all
  mov eax, fnu
  call GfaClose
ENDM

LOF MACRO fnu:REQ
  fnu2 SUBSTR <fnu>,2,1
  invoke GetFileSize, GfaFH[4*fnu2], 0
  EXITM <eax>
ENDM

PROCEDURE MACRO name:REQ
lastproc EQU name
name proc
ENDM

RETURN MACRO
  ret
lastproc endp
ENDM

MsgBox MACRO text:REQ, title:REQ, style:REQ
  invoke MessageBox, MDLG, reparg(text), reparg(title), style
ENDM

MESSAGE MACRO text:REQ, title:REQ, style:REQ, retvar:=<0>
  invoke MessageBox, MDLG, reparg(text), reparg(title), style
  IFDIF <retvar>,<0>
	push ecx			;; if there is an optional
	lea ecx, retvar		;; return variable, it will be used
	mov [ecx], eax		;; otherwise it's eax
	pop ecx
  ENDIF
ENDM

.data?
RvStr$	dd ?		; for str$
rvstring	dd 5 dup (?)	; for str$
EspGlob	dd ?		; for ClearLocals
Add32$	dd ?		; for 
tb$	dd ?		; chr(9)
cr$	dd ?		; chr(13)
crlf$	dd ?		; chr(13, 10) aka 0D0Ah
GfaFH	dd 10 dup(?)	; Gfa file handles, 0-9
Gfa0Str$	dd ?	; ten SysA$ for STR$, STR1$, ...
Gfa1Str$	dd ?
Gfa2Str$	dd ?
Gfa3Str$	dd ?
Gfa4Str$	dd ?
Gfa5Str$	dd ?
Gfa6Str$	dd ?
Gfa7Str$	dd ?
Gfa8Str$	dd ?
Gfa9Str$	dd ?
MiscStrings	dd 3 dup(?)	; dummy for crlf, cr, tb
MsgRet	dd ?		; default for MESSAGE macro
MDLG	dd ?		; better to use this for MessageBox...
snsFlag	dd ?
snsBuf	dd 5 dup (?)

.data
CrLf_txt	db 13, 10, 0
Cr_txt	db 13, 0
Tab_txt	db 9, 0

.code
Gfa_INIT proc
  pushad
;  mov esi, offset GfaStr$	; pointer to multi-STR$
;  xor ebx, ebx
;  .While ebx<10
;	invoke SysAllocStringByteLen, addr Gfa0Str$, 40	; pointer, len
;	mov [esi+4*ebx], eax
;	inc ebx
;  .Endw
  invoke SysAllocStringByteLen, addr CrLf_txt, 2	; these strings
  mov crlf$, eax	; assign pointer to 0D0Ah
  invoke SysAllocStringByteLen, addr Cr_txt, 1	; can be used
  mov cr$, eax	; assign pointer to 0D0Ah
  invoke SysAllocStringByteLen, addr Tab_txt, 1	; in MulCat
  mov tb$, eax	; assign pointer to 0D0Ah
  popad
  ret
Gfa_INIT endp

Gfa_EXIT proc
  pushad
  mov esi, offset Gfa0Str$	; pointer to multi-STR$
  xor ebx, ebx
  .While ebx<10+3
	mov eax, [esi+4*ebx]
	.if eax
		invoke SysFreeString, eax
	.endif
	inc ebx
  .Endw
  popad
  invoke ExitProcess, 0
Gfa_EXIT endp

invoke MessageBox, 0, chr$("What the hell you are doing here??"), chr$("Title"), MB_OK

GfaClose proc
LOCAL ct:DWORD
  push esi
  .if eax==10				; 10=no argument
	mov ct, eax
	.While ct
		dec ct
		mov eax, ct		; 9 to 0
		call GfaCloseN
	.Endw
  .else
	call GfaCloseN
  .endif
  pop esi
  ret
GfaClose endp

GfaCloseN proc	; check if open, if yes close
  lea esi, [GfaFH+4*eax]
  mov eax, [esi]
  .if eax
	invoke CloseHandle, eax
	xor eax, eax
	mov [esi], eax	; clear the handle
  .endif
  ret
GfaCloseN endp

Open_for_input proc HashF:DWORD, OpenF$:DWORD
  mov eax, HashF
  lea ecx, [GfaFH+4*eax]
  push ecx
  invoke CreateFile, OpenF$, GENERIC_READ, FILE_SHARE_READ,
  NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0
  pop ecx
  mov [ecx], eax
  .if eax==INVALID_HANDLE_VALUE
	MsgBox OpenF$, "File not found:", MB_OK
	exit
  .endif
  ret
Open_for_input endp

Open_for_output proc HashF:DWORD, OpenF$:DWORD, OpenA:DWORD
  mov eax, HashF
  lea ecx, [GfaFH+4*eax]
  push ecx
  mov ecx, CREATE_ALWAYS
  .if OpenA=="A"
	mov ecx, OPEN_ALWAYS
  .endif
  invoke CreateFile, OpenF$, GENERIC_WRITE, FILE_SHARE_READ,
  NULL, ecx, FILE_ATTRIBUTE_NORMAL, 0
  pop ecx
  mov [ecx], eax
  .if eax==INVALID_HANDLE_VALUE
	MsgBox OpenF$, "Could not open:", MB_OK
	exit
  .endif
  .if OpenA=="A"
	push eax
	invoke SetFilePointer, eax, 0, 0, FILE_END
	pop eax
  .endif
  ret
Open_for_output endp

GfaInput$ proc HashF:DWORD, tgt:DWORD, bytes:DWORD
LOCAL locBytes:DWORD
  mov ecx, HashF
  lea ecx, [GfaFH+4*ecx]
  invoke ReadFile, [ecx], tgt, bytes, addr locBytes, 0
  ret
GfaInput$ endp

GfaPrint$ proc HashF:DWORD, tgt:DWORD, bytes:DWORD
LOCAL locBytes:DWORD
  .if bytes==0
	mov bytes, len(tgt)
  .endif
  mov ecx, HashF
  lea ecx, [GfaFH+4*ecx]
  invoke WriteFile, [ecx], tgt, bytes, addr locBytes, 0
  ret
GfaPrint$ endp

CSA$ proc		; eax=len=0 && ecx=ptr<>0: use len(ptr)
  push esi
  push edx		; SAT
  mov esi, [edx]	; SAT[0]
  inc esi
  mov [edx], esi	; inc SAT[0]
  .if ecx
	.if eax==0
		push ecx
		mov eax, len(ecx)
		pop ecx
	.endif
  .endif
  invoke SysAllocStringByteLen, ecx, eax	; pointer, len
  pop edx
  mov [edx+4*esi], eax		; eax is the pointer, will be used also by macro
  pop esi
  ret
CSA$ endp

FreeCSA$ proc	; FreeStrings
  push esi
  mov esi, [edx]	; SAT[0]
  .While esi
	push edx
	invoke SysFreeString, [edx+4*esi]
	dec esi
	pop edx
  .Endw
  pop esi
  ret
FreeCSA$ endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
align 4

GfaSTR$ proc
	push esi
	push ebx
	mov ebx, eax				; DDvalue
	lea esi, [Gfa0Str$+4*ecx]	; ecx=slot
	mov eax, [esi]
	.if eax
		invoke SysFreeString, eax
	.endif
	invoke dwtoa, ebx, addr rvstring
	invoke SysAllocStringByteLen, addr rvstring, len(addr rvstring)
	mov [esi], eax
	pop ebx
	pop esi
	ret
GfaSTR$ endp

align 4
AddString proc				; logic: edi=0=init, ecx=0=finish
  .if edi==0
	push ecx				; 32k temp$, enough for Gfa
	invoke SysAllocStringByteLen, 0, 32780
	mov edi, eax			; handle and pointer
	mov Add32$, eax		; save a copy of the handle
	pop ecx
  .endif
  push esi
  .if ecx<999
	.if ecx
		; sns ecx, "foul ecx in AddString:"
		xor ecx, ecx
		xor eax, eax
	.endif
;  .else
;	pushad
;	invoke MessageBox, 0, ecx, chr$("Good ecx:"), MB_OK
;	popad
  .endif
  .if ecx
	mov esi, ecx	; pointer to src
		invoke SysStringByteLen, esi
		.if eax==0 || eax>=IsNeg || eax>32768
;			sns eax, esi
			mov eax, len(esi)
;		.else
;			sns esi, esi
		.endif
		mov ecx, eax	; get the len of the source string
;	endif
	shr ecx, 2		; divide by 4
	rep movsd		; fast memcopy from esi to edi
	mov ecx, eax	; copy the
	and ecx, 3		; non-dword
	rep movsb		; rest as bytes - edi remains moving dest pointer
;	pushad
;	MsgBox Add32$, chr$("Current:"), MB_OK
;	popad
  .elseif eax
	mov esi, eax		; SAT was passed in eax
	sub edi, Add32$		; current end of copies - start = total bytes copied
	push edx			; destination, e.g. MyLocal$
	mov eax, [edx]		; is there already a pointer in MyLocal$?
	.if eax
		invoke SysFreeString, eax	; free the old destination string if present
	.endif
	invoke SysAllocStringByteLen, Add32$, edi	; src is Add32$, len is edi
	pop edx
	mov ecx, [edx]		; old handle
	mov [edx], eax		; mov new handle into MyLocal$
	; check SAT here - ecx=old handle, esi=SAT
	.if ecx
		xor edx, edx		; SAT count; if old$ is in SAT
		.While edx<=[esi]
			inc edx
			.if ecx==[esi+4*edx]			; old handle is in SAT, replace
				mov [esi+4*edx], eax	; mov new handle into SAT
				; pushad
				; invoke MessageBox, 0, STR$(edx), chr$("Old slot:"), MB_OK
				; popad
				.break
			.endif
		.Endw
		.if edx>[esi]
			mov [esi], edx			; create new slot in SAT
			mov [esi+4*edx], eax	; mov new handle into SAT
			; pushad
			; invoke MessageBox, 0, STR$(edx), chr$("New slot:"), MB_OK
			; popad
		.endif
	.endif
	invoke SysFreeString, Add32$	; free the temporary string
  .endif
  pop esi
  ret
AddString endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

ClrLoc proc			; first instruction after LOCALS - eax will be zero on exit
	pop EspGlob	; save the return address to a global variable - now
					; the stack is identical to the calling procedure	
	xchg eax, ecx	; save ecx
	mov ecx, ebp	; base page of calling procedure
	sub ecx, esp	; ebp - esp = No. of bytes in locals
	mov esp, ebp	; discard existing locals
	shr ecx, 2		; divide by four
@@:	push 0		; dwords on stack
	loop @B
	xchg eax, ecx	; restore ecx, 0 to eax
	push EspGlob	; restore the return address
	ret
ClrLoc endp

COMMENT @
OPT_Ren Gfa2Masm.inc
OPT_Run no @
